﻿Imports System.Data.OracleClient
Imports System.Data
Imports System.Data.SqlClient
Imports BCb2b.Enterlan
Imports System.Configuration.ConfigurationSettings
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Partial Class BusquedaClientes
    Inherits ClaseBase
    Private COD As String
    Private RSOCIAL_COD As String
    Private NOMBRE As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private CREAR_DELEGACION As Boolean
    'PROPIEDADES
    Public ReadOnly Property PROP_COD() As String
        Get
            Return Me.COD
        End Get
    End Property
    Public ReadOnly Property PROP_RSOCIAL_COD() As String
        Get
            Return Me.RSOCIAL_COD
        End Get
    End Property
    Public ReadOnly Property PROP_NOMBRE() As String
        Get
            Return Me.NOMBRE
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property
    Public ReadOnly Property PROP_CREAR_DELEGACION() As String
        Get
            Return Me.CREAR_DELEGACION
        End Get
    End Property
    'FIN PROPIEDADES

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        lblError.Visible = False
        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If Not vPerfiles.prop_ES_CLI_O_ERROR Then
            If Not Page.IsPostBack Then
                Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
                Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
                Dim vConexion As String = Conexion.GenerarStringConexion(Me)

                tboxCodigo.Attributes.Add("onkeydown", "javascript:KeyDownCod();")
                tboxCodigo.Attributes.Add("onfocus", "javascript:return SetCursorToTextEnd(this.id);")

                Dim vCifAbuscar As String = Request("f")
                If vCifAbuscar <> "" Then
                    tboxCodigo.Text = vCifAbuscar
                End If

                PGVBusqueda.VirtualItemCount = GetRowCount(vEmpgrupoCod, vTipVc, vConexion)
                BindPagingGrid(vEmpgrupoCod, vTipVc, vConexion)

                If tboxCodigo.Text <> "" Then
                    PGVSimilares.VirtualItemCount = GetRowCount_Sim(vEmpgrupoCod, vTipVc, vConexion)
                    BindPagingGrid_Sim(vEmpgrupoCod, vTipVc, vConexion)
                Else
                    PGVSimilares.VirtualItemCount = 0
                    PGVSimilares.DataSource = Nothing
                    PGVSimilares.DataBind()
                    UPBCliente.Update()
                End If
                tboxCodigo.Focus()
            End If
        Else
            Response.Redirect("~/Expirado.aspx")
        End If
    End Sub

    'GRIDVIEW DE BUSQUEDA NORMAL
    Private Function GetRowCount(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pConexion As String) As Integer
        Dim vGvagenteCod As OracleNumber = ObtenerGvagenteCod()
        Dim vEstados As String = DameEstadosSeleccionados()
        Dim vGgclipr As New BCb2b.ggclipr()
        Dim vTotal As Integer = vGgclipr.cuantos_Por_RSocial(pEmpgrupoCod, tboxCodigo.Text, tboxCodigo.Text, tboxCodigo.Text, Session("ver_clientes"), pTipVc, vGvagenteCod, Session("empresa").prop_cod, "S", vEstados, pConexion)
        Return vTotal
    End Function
    Private Sub BindPagingGrid(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pConexion As String)
        PGVBusqueda.DataSource = GetDataPage(pEmpgrupoCod, pTipVc, pConexion)
        PGVBusqueda.DataBind()
        UPBCliente.Update()
    End Sub
    Private Function GetDataPage(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pConexion As String) As ArrayList
        Dim vListaClientes As New ArrayList
        Dim vGvagenteCod As OracleNumber = ObtenerGvagenteCod()
        Dim vPaginaInicio As String = ((PGVBusqueda.PageIndex) * PGVBusqueda.PageSize) + 1
        Dim vPaginaFin As String = ((PGVBusqueda.PageIndex + 1) * PGVBusqueda.PageSize)
        Dim vOrdenadoPor As String = ""
        Dim vEstados As String = DameEstadosSeleccionados()
        Dim vGgclipr As New BCb2b.ggclipr()
        vListaClientes = vGgclipr.listado_Clientes_Por_RSocial_paginado(pEmpgrupoCod, tboxCodigo.Text, tboxCodigo.Text, tboxCodigo.Text, Session("ver_clientes"), pTipVc, vGvagenteCod, vPaginaInicio, vPaginaFin, vOrdenadoPor, Session("empresa").prop_cod, "S", vEstados, pConexion)
        Return vListaClientes
    End Function
    Protected Sub PGVBusqueda_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PGVBusqueda.PageIndexChanging
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        PGVBusqueda.PageIndex = e.NewPageIndex
        BindPagingGrid(vEmpgrupoCod, vTipVc, vConexion)
        BindPagingGrid_Sim(vEmpgrupoCod, vTipVc, vConexion)
    End Sub
    Protected Sub PGVBusqueda_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles PGVBusqueda.SelectedIndexChanged
        GestionaClienteSeleccionado(PGVBusqueda)
    End Sub
    'FIN GRIDVIEW DE BUSQUEDA NORMAL

    'GRIDVIEW DE BUSQUEDA POR SIMILITUD
    Private Function GetRowCount_Sim(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pConexion As String) As Integer
        Dim vGvagenteCod As OracleNumber = ObtenerGvagenteCod()
        Dim vGgclipr As New BCb2b.ggclipr()
        Dim vSimilitud As Integer = CInt(ConfigurationManager.AppSettings("porcent_minimo_similitud_clientes"))
        Dim vTotal As Integer = vGgclipr.cuantos_Por_RSocial_por_similitud(pEmpgrupoCod, tboxCodigo.Text, tboxCodigo.Text, tboxCodigo.Text, Session("ver_clientes"), pTipVc, vGvagenteCod, vSimilitud, Session("empresa").prop_cod, "S", pConexion)
        Return vTotal
    End Function
    Private Sub BindPagingGrid_Sim(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pConexion As String)
        PGVSimilares.DataSource = GetDataPage_Sim(pEmpgrupoCod, pTipVc, pConexion)
        PGVSimilares.DataBind()
        UPBCliente.Update()
    End Sub
    Private Function GetDataPage_Sim(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pConexion As String) As ArrayList
        Dim vListaClientes As New ArrayList
        Dim vGvagenteCod As OracleNumber = ObtenerGvagenteCod()
        Dim vPaginaInicio As String = ((PGVSimilares.PageIndex) * PGVSimilares.PageSize) + 1
        Dim vPaginaFin As String = ((PGVSimilares.PageIndex + 1) * PGVSimilares.PageSize)
        Dim vOrdenadoPor As String = ""
        Dim vSimilitud As Integer = CInt(ConfigurationManager.AppSettings("porcent_minimo_similitud_clientes"))
        Dim vGgclipr As New BCb2b.ggclipr()
        vListaClientes = vGgclipr.listado_Clientes_Por_RSocial_paginado_por_similitud(pEmpgrupoCod, tboxCodigo.Text, tboxCodigo.Text, tboxCodigo.Text, Session("ver_clientes"), pTipVc, vGvagenteCod, vSimilitud, vPaginaInicio, vPaginaFin, vOrdenadoPor, Session("empresa").prop_cod, "S", pConexion)
        Return vListaClientes
    End Function
    Protected Sub PGVSimilares_PageIndexChanging(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewPageEventArgs) Handles PGVSimilares.PageIndexChanging
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        PGVSimilares.PageIndex = e.NewPageIndex
        BindPagingGrid_Sim(vEmpgrupoCod, vTipVc, vConexion)
        BindPagingGrid(vEmpgrupoCod, vTipVc, vConexion)
    End Sub
    Protected Sub PGVSimilares_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles PGVSimilares.SelectedIndexChanged
        GestionaClienteSeleccionado(PGVSimilares)
    End Sub
    'FIN GRIDVIEW DE BUSQUEDA POR SIMILITUD

    Protected Sub btnCrearCliente_Click(sender As Object, e As EventArgs) Handles btnCrearCliente.Click
        Dim vGgclipr As New BCb2b.ggclipr()
        Session("new_cliente") = vGgclipr
        Response.Redirect("CrearCliente.aspx")
    End Sub
    Private Sub GestionaClienteSeleccionado(ByVal pGridView As GridView)
        Try
            Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
            Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
            Dim vConexion As String = Conexion.GenerarStringConexion(Me)

            Dim vFila As GridViewRow
            vFila = pGridView.SelectedRow

            Dim vGgcliprCod As String = vFila.Cells(0).Text
            Dim vRsocialCod As String = vFila.Cells(1).Text
            Dim vNombre As String = vFila.Cells(2).Text

            Me.COD = vGgcliprCod
            Me.RSOCIAL_COD = vRsocialCod
            Me.NOMBRE = vNombre
            Me.EMPRESA = Session("empresa").prop_cod
            Me.GRUPO = vEmpgrupoCod
            Me.TIPVC = vTipVc
            Me.CREAR_DELEGACION = False

            lblError.Visible = False
            Dim vGgclipr As New BCb2b.ggclipr(vGgcliprCod, vEmpgrupoCod, vTipVc, vConexion)
            Session("cliente") = vGgclipr
            Server.Transfer("CrearCliente.aspx")
        Catch ex As Exception
            lblError.Visible = True
            lblError.Text = ex.Message.ToString
        End Try
    End Sub
    Protected Sub CrearDelegacion_Command(sender As Object, e As CommandEventArgs)
        Dim cod_cli As String = e.CommandName.ToString
        Dim rsocial_cod As String = e.CommandArgument.ToString
        Me.COD = cod_cli
        Me.RSOCIAL_COD = rsocial_cod
        Me.GRUPO = ConfigurationManager.AppSettings("grupo")
        Me.EMPRESA = ConfigurationManager.AppSettings("empresa")
        Me.TIPVC = ConfigurationManager.AppSettings("venta")
        Me.CREAR_DELEGACION = True
        Server.Transfer("CrearCliente.aspx")
    End Sub
    Protected Sub tboxCodigo_TextChanged(sender As Object, e As EventArgs) Handles tboxCodigo.TextChanged
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)

        PGVBusqueda.VirtualItemCount = GetRowCount(vEmpgrupoCod, vTipVc, vConexion)
        BindPagingGrid(vEmpgrupoCod, vTipVc, vConexion)

        If tboxCodigo.Text <> "" Then
            PGVSimilares.VirtualItemCount = GetRowCount_Sim(vEmpgrupoCod, vTipVc, vConexion)
            BindPagingGrid_Sim(vEmpgrupoCod, vTipVc, vConexion)
        Else
            PGVSimilares.VirtualItemCount = 0
            PGVSimilares.DataSource = Nothing
            PGVSimilares.DataBind()
            UPBCliente.Update()
        End If

        ScriptManager.GetCurrent(Me.Page).SetFocus(tboxCodigo)
    End Sub
    Private Function ObtenerGvagenteCod() As OracleNumber
        Dim vGvagenteCod As OracleNumber = OracleNumber.Null
        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))
        If Not Session("agente") Is Nothing And vPerfiles.prop_TIPO_PERFIL <> 0 Then
            vGvagenteCod = CType(Session("agente").prop_cod.ToString, OracleNumber)
        Else
            vGvagenteCod = OracleNumber.Null
        End If
        Return vGvagenteCod
    End Function

    'GESTION DE ESTADOS
    Protected Sub chkAct_CheckedChanged(sender As Object, e As EventArgs) Handles chkAct.CheckedChanged
        FiltrarPorEstado()
    End Sub
    Protected Sub chkH_CheckedChanged(sender As Object, e As EventArgs) Handles chkH.CheckedChanged
        FiltrarPorEstado()
    End Sub
    Protected Sub chkM_CheckedChanged(sender As Object, e As EventArgs) Handles chkM.CheckedChanged
        FiltrarPorEstado()
    End Sub
    Protected Sub chkPC_CheckedChanged(sender As Object, e As EventArgs) Handles chkPC.CheckedChanged
        FiltrarPorEstado()
    End Sub
    Protected Sub chkPot_CheckedChanged(sender As Object, e As EventArgs) Handles chkPot.CheckedChanged
        FiltrarPorEstado()
    End Sub
    Private Sub FiltrarPorEstado()
        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        PGVBusqueda.VirtualItemCount = GetRowCount(vEmpgrupoCod, vTipVc, vConexion)
        BindPagingGrid(vEmpgrupoCod, vTipVc, vConexion)
        If tboxCodigo.Text <> "" Then
            PGVSimilares.VirtualItemCount = GetRowCount_Sim(vEmpgrupoCod, vTipVc, vConexion)
            BindPagingGrid_Sim(vEmpgrupoCod, vTipVc, vConexion)
        Else
            PGVSimilares.VirtualItemCount = 0
            PGVSimilares.DataSource = Nothing
            PGVSimilares.DataBind()
            UPBCliente.Update()
        End If
        tboxCodigo.Focus()
    End Sub
    Private Function DameEstadosSeleccionados() As String
        Dim estados_check As String = ""

        If chkAct.Checked = True Then
            estados_check = estados_check & "'A'"
        End If
        If chkH.Checked = True Then
            If estados_check <> "" Then
                estados_check = estados_check & ","
            End If
            estados_check = estados_check & "'H'"
        End If
        If chkM.Checked = True Then
            If estados_check <> "" Then
                estados_check = estados_check & ","
            End If
            estados_check = estados_check & "'M'"
        End If
        If chkPC.Checked = True Then
            If estados_check <> "" Then
                estados_check = estados_check & ","
            End If
            estados_check = estados_check & "'PC'"
        End If
        If chkPot.Checked = True Then
            If estados_check <> "" Then
                estados_check = estados_check & ","
            End If
            estados_check = estados_check & "'POT'"
        End If

        Return estados_check
    End Function
    'FIN GESTION DE ESTADOS
End Class
