﻿Imports System.Data.OracleClient
Imports System.Data
Imports System.Data.OleDb
Imports CTI.Utilities.Log
Partial Class CrearOferta
    Inherits claseBase

    Private NOFE As String
    Private TIPOOFE As String
    Private EMPRESA As String
    Private GRUPO As String
    Private TIPVC As String
    Private _lineas As List(Of BCb2b.COferta_linOff)
    Private num_lineas_error_costo As Integer = 0

    'PROPIEDADES
    Public ReadOnly Property PROP_N_OFE_SEL() As String
        Get
            Return Me.NOFE
        End Get
    End Property
    Public ReadOnly Property PROP_TIPO_OFE_SEL() As String
        Get
            Return Me.TIPOOFE
        End Get
    End Property
    Public ReadOnly Property PROP_EMPRESA() As String
        Get
            Return Me.EMPRESA
        End Get
    End Property
    Public ReadOnly Property PROP_GRUPO() As String
        Get
            Return Me.GRUPO
        End Get
    End Property
    Public ReadOnly Property PROP_TIPVC() As String
        Get
            Return Me.TIPVC
        End Get
    End Property
    Private Property lineas As List(Of BCb2b.COferta_linOff)
        Get
            Return _lineas
        End Get
        Set(value As List(Of BCb2b.COferta_linOff))
            _lineas = value
        End Set
    End Property
    'FIN PROPIEDADES

    'METODOS AJAX
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtenerPlazo(ByVal ModificandoSN As String) As String
        Dim ag As New BCb2b.gvagente()
        Try
            If Session("agente") Is Nothing And Session("cliente") Is Nothing Then
                'TODO: Mandamos a expirado. habrá que hacer una función que compruebe si se ha ido la sesión.
                Server.Transfer("~/Expirado.aspx")
            Else
                If Not Session("agente") Is Nothing Then
                    ag = Session("agente")
                Else
                    Dim cli As New BCb2b.ggclipr()
                    cli = Session("cliente")
                    ag = New BCb2b.gvagente(cli.prop_GVAGENTE_COD, ConfigurationManager.AppSettings("grupo"), 0)
                End If

                Dim observacionPlazoAgente As New BCb2b.GGCLIPROBS(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("compra"), ag.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("OBPZ"))
                Return observacionPlazoAgente.PROP_COMENTARIO
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtenerPlazo]: agente = {agente}", ag.prop_COD)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)>
    Public Function obtenerSuRef(ByVal grupo As String, ByVal tip_vc As String, ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal ModificandoSN As String) As String

        Try

            If (ModificandoSN = "S") Then
                Return "modificando!!!"
            Else

                Dim ggpreres As New BCb2b.GGPRERES(grupo, COD_CLI, codigo_Art)

                Return ggpreres.prop_SREFER

            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtenerSuRef]: grup = {grup} ggclipr = {CLI} gaart = {Art}", grupo, COD_CLI, codigo_Art)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function InsertarPrecioEspecial(ByVal grupo As String, ByVal empresa As String, ByVal tip_vc As String, ByVal ggofetip_cod As String, ByVal ggclipr_cod As String, ByVal gaart_cod As String, ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal obser_prec_esp As String) As String
        Dim precio_esp_final As Double = 0
        Try
            cantidad = GestionaNumero(cantidad)
            precio = GestionaNumero(cantidad)
            descuento = GestionaNumero(descuento)

            If cantidad <> "" And precio <> "" And descuento <> "" Then
                'AMC_NE119.PRECIOS ESPECIALES
                '----------------------------------------------
                'INSERTAMOS PRECIO ESPECIAL
                Dim precioEspecial = New BCb2b.crearPrecioEspecial()
                precio_esp_final = FormatNumber((CDbl(precio) * CDbl(1)) - ((CDbl(precio) * CDbl(1)) * (CDbl(descuento) / 100)), 2)

                obser_prec_esp = ggofetip_cod.ToUpper & " " & obser_prec_esp & " " & precio_esp_final
                precioEspecial.crear_con_params(grupo, tip_vc, ggclipr_cod, gaart_cod, precio_esp_final, obser_prec_esp, ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"), ConfigurationManager.AppSettings("Oferta"))

                'FIN AMC_NE119. PRECIOS ESPECIALES
                '----------------------------------------------
            End If

            Return "0"
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.InsertarPrecioEspecial]: grup = {grupo} tip = {tip} cli = {cli} gaart = {gaart} precio = {precio} obser = {obser}", grupo, tip_vc, ggclipr_cod, gaart_cod, precio_esp_final, obser_prec_esp)
            Return "1"
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)>
    Public Function Crear_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String

        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)
            ggpreres.actualizar_su_ref(ConfigurationManager.AppSettings("grupo"), codclinumber, codigo_Art, larefmodif)
            ggpreres.GGPRERES_INSERTAR(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
            Return ""
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Crear_su_ref]: art = {art} cli = {cli} ref = {ref}", codigo_Art, COD_CLI, larefmodif)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)>
    Public Function Cambiar_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String

        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)
            ggpreres.actualizar_su_ref(ConfigurationManager.AppSettings("grupo"), codclinumber, codigo_Art, larefmodif)
            ggpreres.GGPRERES_INSERTAR(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
            Return ""
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Cambiar_su_ref]: art = {art} cli = {cli} ref = {ref}", codigo_Art, COD_CLI, larefmodif)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)>
    Public Function Comprobar_su_ref(ByVal codigo_Art As String, ByVal COD_CLI As String, ByVal larefmodif As String) As String

        Try
            'cambiar su ref para ese cli y art
            Dim ggpreres As New BCb2b.GGPRERES()
            Dim codclinumber As New OracleNumber
            codclinumber = CType(COD_CLI, OracleNumber)

            Dim parametro_ref As String = "GGPRERES_" + ConfigurationManager.AppSettings("venta") + "_SREFER_UNICA"
            Dim PARAMETRO As New BCb2b.empparam(parametro_ref, GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            Dim PARAM_REFER As String = PARAMETRO.prop_VALOR
            If (PARAM_REFER = "S") Then
                Dim mensaje As String = ""
                mensaje = ggpreres.GGPRERES_CONTROL_SREFER_UNICA(ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), codclinumber, codigo_Art, larefmodif)
                If (mensaje = "") Then
                    Return "SI"
                Else
                    Return "NO"
                End If
            Else
                Return "NO"
            End If

        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Comprobar_su_ref]: art = {art} cli = {cli} ref = {ref}", codigo_Art, COD_CLI, larefmodif)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod()> _
    Public Function ES_KIT(ByVal empgrupo_cod As String, ByVal gaart_cod As String) As Boolean
        Dim es As Boolean = False
        Try
            Dim estruc As New BCb2b.gaestru()
            es = estruc.ES_KIT(empgrupo_cod, gaart_cod)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.ES_KIT] grupo = {grupo} art = {art} ", empgrupo_cod, gaart_cod)
        End Try

        Return es
    End Function
    <Ajax.AjaxMethod()> _
    Public Function ES_KIT_SUSTITUCION(ByVal empgrupo_cod As String, ByVal gaart_cod As String) As Boolean
        Dim es As Boolean = False
        Try
            Dim estruc As New BCb2b.gaestru()
            es = estruc.ES_KIT_SUSTITUCION(empgrupo_cod, gaart_cod)
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.ES_KIT_SUSTITUCION] grupo = {grupo} art = {art} ", empgrupo_cod, gaart_cod)
        End Try
        Return es
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function guardar_observacion(ByVal vOBSER As String) As String
        'AQUI LLAMO AL A FUCNION QUE INSERTA O NO SEGÚN LO QUE TENGA QUE HACER.

        Dim PARAM_OBS As String = ""
        Try
            'modificar obser
            Dim PARAMETRO As New BCb2b.empparam(ConfigurationManager.AppSettings("CRM_GGOFETIP_OPO_OBS"), GRUPO, EMPRESA, Session("USUARIOB2B").PROP_COD)
            PARAM_OBS = PARAMETRO.prop_VALOR

            Dim ggOFEobs As New BCb2b.CObs_oferta(session("cabecera").prop_empgrupo_cod().ToString, session("cabecera").prop_emp_cod().ToString, session("cabecera").prop_tip_vc().ToString, session("cabecera").prop_GGOFETIP_COD().ToString, session("cabecera").prop_N_OFE().ToString, PARAM_OBS)
            ggOFEobs.MODIFICAR_OBS("", vOBSER)
            Return vOBSER
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.guardar_observacion]: grup = {grup} emp = {emp} tip = {tip} ggofetip = {ggofetip} ofe = {ofe} obs = {obs}", Session("cabecera").prop_empgrupo_cod().ToString, Session("cabecera").prop_emp_cod().ToString, Session("cabecera").prop_tip_vc().ToString, Session("cabecera").prop_GGOFETIP_COD().ToString, Session("cabecera").prop_N_OFE().ToString, PARAM_OBS)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtenerCuc(ByVal grupo As String, ByVal empresa As String, ByVal tip_vc As String, ByVal codigo_Art As String) As String
        If grupo = "" Then
            grupo = ConfigurationManager.AppSettings("grupo")
        End If
        If empresa = "" Then
            empresa = ConfigurationManager.AppSettings("empresa")
        End If
        If tip_vc = "" Then
            tip_vc = ConfigurationManager.AppSettings("venta")
        End If

        Dim PRECIO_TARIFA_AUX As Double = 0
        Dim PARAM_TARIFA As New BCb2b.empparam()
        Try
            Dim PARAM_MARGEN_COSTE As New BCb2b.empparam("B2B_MARGEN_COSTE", grupo, empresa, Nothing)
            PARAM_TARIFA = New BCb2b.empparam("B2B_TARIFA_COSTE", grupo, empresa, Nothing)

            Dim ARTICULOAUX As New BCb2b.CArticulo(grupo, codigo_Art.ToUpper)
            Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, tip_vc)


            PRECIO_TARIFA_AUX = (PRECIO_TARIFA + (PRECIO_TARIFA * PARAM_MARGEN_COSTE.prop_VALOR) / 100)

            Return FormatNumber(PRECIO_TARIFA_AUX, 2).ToString
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtenerCuc]: grup = {grup} empr = {empr} tip = {tip} tarif = {tarif} prec = {prec}", grupo, empresa, tip_vc, PARAM_TARIFA.prop_VALOR, PRECIO_TARIFA_AUX)
            Return ex.Message.ToString()
        End Try
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GestionaNumero(ByVal numero As String, Optional ByVal v_cultura As String = "") As String
        Try
            If numero <> "" And IsNumeric(numero) Then
                If v_cultura <> "" Then
                    Dim cnum As New BCb2b.Utilities()
                    numero = cnum.ConvierteNumSegunCulture(numero, v_cultura)
                End If
            Else
                numero = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.GestionaNumero]: nume = {nume} cultu = {cultu}", numero, v_cultura)
        End Try

        Return numero
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GestionaFecha(ByVal fecha As String) As String
        Try
            If fecha = "" Or IsDate(fecha) = False Then
                fecha = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearPedido.GestionaFecha] fec = {fec}", fecha)
        End Try

        Return fecha
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function GESTION_DESCRIP_ART_TIRAS_ROLLOS(ByVal empgrupo_cod As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal vCANTIDAD As String) As String
        Dim anadir_a_descrip As String = ""
        Dim clasi1 As String = ""
        Dim clasi2 As String = ""
        Try
            'COMPROBAMOS PARAMETROS
            Dim param1 As String = "AMC_GV082_CLASIFICACION_ART"
            Dim param2 As String = "GGXXXLIN_GACLATIP_CLASIF_AUT"

            Dim dameparam As New BCb2b.CParametros()
            clasi1 = dameparam.dame_param(param1)
            clasi2 = dameparam.dame_param(param2)

            Dim valor1 As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, clasi1)
            Dim valor2 As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, clasi2)

            If valor1.prop_GACLASIF_COD = "S" Then
                Dim gacodbar As New BCb2b.gacodbar()
                Dim existe_gaart_en_gacodbar As Boolean = gacodbar.ExisteGaartEnGacodbarPorGacodtip(empgrupo_cod, vGAART_COD, ConfigurationManager.AppSettings("UNID"))
                Dim art As New BCb2b.gaart(empgrupo_cod, vGAART_COD)

                Dim ancho As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, "ANCHO")
                Dim largo As New BCb2b.gaartclasi(empgrupo_cod, vGAART_COD, "LARGO")

                If valor2.prop_GACLASIF_COD = "S" And existe_gaart_en_gacodbar = False And art.prop_GAUNITIP_UNI1 = "UN" Then
                    anadir_a_descrip = "Metros Cuadrados = (" & ancho.prop_VALOR & " x " & largo.prop_VALOR & ") " & vCANTIDAD
                Else
                    anadir_a_descrip = "Metros Cuadrados"
                End If

            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.GestionaNumero]: clas1 = {clas1} clas2 = {clas2} art = {art}", clasi1, clasi2, vGAART_COD)
        End Try


        If anadir_a_descrip = "" Then
            Return Trim(vDESCRIP)
        Else
            Return Trim(vDESCRIP & vbCrLf & anadir_a_descrip)
        End If

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Dame_Unidad_Gaart(ByVal grupo As String, ByVal gaart_cod As String) As String
        Dim valor As String = ""
        Try
            Dim ARTICULOAUX As New BCb2b.CArticulo(grupo, gaart_cod.ToUpper)
            valor = ARTICULOAUX.prop_gaunitip_uni1
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Dame_Unidad_Gaart]: grup = {grup} gaart = {gaart}", grupo, gaart_cod)
        End Try

        Return valor
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function ValidarPrecioLinea(ByVal gaart_cod As String, ByVal cod_cli As String, ByVal precio As String, ByVal cantidad As String, ByVal descuento As String, ByVal v_cultura As String) As String
        Dim conexionole As IDbConnection = BCb2b.cconexion_ole.conectar(ConfigurationManager.AppSettings("usuario"), ConfigurationManager.AppSettings("pass"), ConfigurationManager.AppSettings("bbdd"))
        Dim transaccion_valida_prec As IDbTransaction
        transaccion_valida_prec = conexionole.BeginTransaction

        Dim mensajeinfo As String = ""
        Dim mensajeerror As String = ""
        Dim ES_VALIDO As String = "N"

        Dim prec_aux As Double = 0

        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If gaart_es_tira_o_rollo(ConfigurationManager.AppSettings("grupo"), gaart_cod) = "N" Then
            If descuento <> "" And precio <> "" Then

                prec_aux = precio - (precio * descuento / 100)

                Try
                    'TODO: JCE. no encuentra el metodo validar precio.
                    'ES_VALIDO = AMC_B2B_PKG.AMC_B2B_PKG.VALIDAR_PRECIO(transaccion_valida_prec, ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("venta"), cod_cli, gaart_cod, prec_aux, CDate(Now.ToShortDateString), mensajeinfo, mensajeerror)
                    transaccion_valida_prec.Commit()
                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.ValidarPrecioLinea]: cli = {cli} art = {art} prec = {prec} mensaje = {mensaje} ", cod_cli, gaart_cod, prec_aux, mensajeerror)
                    transaccion_valida_prec.Rollback()
                Finally
                    transaccion_valida_prec.Dispose()
                End Try

                Dim PARAM_TARIFA As New BCb2b.empparam(ConfigurationManager.AppSettings("PARAM_TARIFA_CUC"), ConfigurationManager.AppSettings("grupo"), ConfigurationManager.AppSettings("empresa"), Nothing)
                Dim ARTICULOAUX As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), gaart_cod.ToUpper)
                Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, ConfigurationManager.AppSettings("venta"))

                If PRECIO_TARIFA = 0 Then
                    Return "#OK" 'permitimos pedidos precio 0
                End If

                If mensajeerror <> "" Then
                    Return mensajeerror
                Else
                    Return "#OK"
                End If
            Else
                Return "#OK"
            End If
        Else
            Return "#OK"
        End If
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function Dame_TipoError_de_Error(ByVal cod_error As String) As String
        If cod_error.IndexOf("ERROR") <> -1 Then
            Return "#ERROR"
        ElseIf cod_error.IndexOf("WARNING") <> -1 Then
            Return "#WARNING"
        Else
            Return "#OK"
        End If
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_Descrip_Error(ByVal cod_error As String, ByVal culture As String) As String
        Dim resultado As String = ""
        Try
            'ES NECESARIO HACER ESTO PORQUE SINO NO TRADUCE
            If (String.IsNullOrEmpty(culture)) Then
                culture = "Auto"
            End If
            Dim ci As New System.Globalization.CultureInfo(culture)
            ci.NumberFormat.CurrencyDecimalDigits = 3
            ci.NumberFormat.NumberGroupSeparator = ""
            ci.NumberFormat.NumberDecimalSeparator = ","
            System.Threading.Thread.CurrentThread.CurrentCulture = ci
            System.Threading.Thread.CurrentThread.CurrentUICulture = ci
            resultado = GetGlobalResourceObject("general", cod_error.Replace("#", "")) 'en los resources no deja poner #
            If resultado Is Nothing Then 'SI NO EXISTE EL CODIGO DE ERROR QUE LO MUESTRE PARA SABER QUE HAY QUE TRADUCIR
                resultado = cod_error
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Obtener_Descrip_Error]: error = {error} cultu = {cultu}", cod_error, culture)
        End Try

        Return resultado
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function CompruebaSiDatosValidos(ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal v_cultura As String) As Boolean
        CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)
        PR_PRECIO = GestionaNumero(PR_PRECIO, v_cultura)
        DESCUENTO = GestionaNumero(DESCUENTO, v_cultura)

        Dim es_valido As Boolean = False
        If CANTIDAD <> "" And PR_PRECIO <> "" And DESCUENTO <> "" Then
            es_valido = True
        End If
        Return es_valido
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function guardar_linea(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal vGGOFETIP_COD As String, ByVal vN_OFE As String, ByVal vN_LIN As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal vF_ENTRPREV As String, ByVal total As String, ByVal plazo As String, ByVal vgaunitip_uni1 As String, ByVal v_ancho As String, ByVal v_alto As String, ByVal v_tiras As String, ByVal v_rollos As String, ByVal v_m2 As String, ByVal v_equi_unpr As String, ByVal v_despercidio As String, ByVal tipo_error As String, ByVal mensajeInfo As String, ByVal v_cultura As String) As String
        Dim resultado As String = ""
        Dim ERRORCOSTE As Boolean = False
        Dim ATENCIONCOSTE As Boolean = False
        Dim vienedeofertaSN As Boolean = False
        Dim OBSERVACIONCOSTE As String = ""
        Try
            If CompruebaSiDatosValidos(CANTIDAD, PR_PRECIO, DESCUENTO, v_cultura) Then

                Dim es_tira_o_rollo As String = gaart_es_tira_o_rollo(empgrupoCod, vGAART_COD.ToUpper)

                'MIRAMOS EL MARGEN.
                Dim PARAM_MARGEN_COSTE As New BCb2b.empparam("B2B_MARGEN_COSTE", empgrupoCod, EMCOD, Nothing)
                Dim PARAM_TARIFA As New BCb2b.empparam("B2B_TARIFA_COSTE", empgrupoCod, EMCOD, Nothing)

                Dim ARTICULOAUX As New BCb2b.CArticulo(empgrupoCod, vGAART_COD.ToUpper)
                Dim PRECIO_TARIFA As Double = ARTICULOAUX.calcula_precio_tarifa(PARAM_TARIFA.prop_VALOR, vTIP_VC)

                Dim PRECIO_TARIFA_AUX As Double = 0
                PRECIO_TARIFA_AUX = (PRECIO_TARIFA + (PRECIO_TARIFA * PARAM_MARGEN_COSTE.prop_VALOR) / 100) * CANTIDAD

                Dim art_ESP As String = ConfigurationManager.AppSettings("COD_GAART_ESP")

                If (CDbl(total) < CDbl(PRECIO_TARIFA_AUX)) And es_tira_o_rollo = "N" And vGAART_COD.ToUpper <> art_ESP.ToUpper Then
                    'AMC_NE174
                    Select Case tipo_error
                        Case "#ERROR"
                            ERRORCOSTE = True 'MENOR QUE CUC Y QUE TARIF_ESTR
                        Case "#WARNING"
                            ATENCIONCOSTE = True 'MENOR QUE EL CUC PERO NO MENOR QUE TARIF_ESTR
                            OBSERVACIONCOSTE = mensajeInfo
                        Case "#OK"
                            OBSERVACIONCOSTE = ""
                    End Select
                End If

                resultado = tipo_error

                'SRA CLIENTE
                'Dim LINEAOFE As New BCb2b.COferta_linOff(empgrupoCod, EMCOD, vTIP_VC, vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, Nothing, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE)
                Dim LINEAOFE As New BCb2b.COferta_linOff(empgrupoCod, EMCOD, vTIP_VC, vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, vgaunitip_uni1, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE, ATENCIONCOSTE, v_ancho, v_alto, v_tiras, v_rollos, v_m2, v_equi_unpr, v_despercidio, OBSERVACIONCOSTE, v_cultura)

                Dim GAUNITP_UNI1 As String = ""
                Dim vGGOFECAB_GGCLIPR_COD As String = COD_CLI
                'jvc. aqui pongo la propiedad lineas para pasarselo al otro lado.

                Dim VCANTIDAD As String = CANTIDAD
                Dim list_LINEAS As New List(Of BCb2b.COferta_linOff)
                Try
                    list_LINEAS = Session("lineasOferta")
                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.obtenerlineas] lineas = {@lineas}", Session("lineasOferta"))
                End Try

                lineas = LINEAOFE.addLinea(list_LINEAS, LINEAOFE, ConfigurationManager.AppSettings("obstip_articulo_idiomas"), Session("idioma_spyro"))

                Session("lineasOferta") = lineas

                If resultado = "" Then
                    resultado = LINEAOFE.prop_N_LIN
                End If
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.guardar_linea]: grupo = {grupo} emp = {emp} tip = {tip} ofetip = {ofetip} ofe = {ofe} lin = {lin} art = {art} descr = {descr} cant = {cant} prec = {prec} f_entr = {f_entr} uni = {uni} cli = {cli} desc = {desc} plaz = {plaz} vienedeofeSN = {vienedeofeSN} costeerror = {costeerror} costeatenci = {costeatenci} ancho = {ancho} alto = {alto} tiras = {tiras} rollos = {rollos} m2 = {m2} equi_unpr = {equi_unpr} desper = {desper} costeobser = {costeobser}", empgrupoCod, EMCOD, vTIP_VC, vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, PR_PRECIO, vF_ENTRPREV, vgaunitip_uni1, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE, ATENCIONCOSTE, v_ancho, v_alto, v_tiras, v_rollos, v_m2, v_equi_unpr, v_despercidio, OBSERVACIONCOSTE)
        End Try
        'fuerzo el return
        Return resultado

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function obtener_precio_especial(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal cod_cli As String, ByVal vGAART_COD As String, ByVal CANTIDAD As String, ByVal v_cultura As String) As String
        Dim prec_especial As String = ""
        Try
            CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)

            If vGAART_COD <> ConfigurationManager.AppSettings("COD_GAART_ESP") And CANTIDAD <> "" Then
                Dim precioEspecial As New BCb2b.crearPrecioEspecial()

                Dim valor As String = precioEspecial.damePrecEspecial(empgrupoCod, vTIP_VC, cod_cli, vGAART_COD, CANTIDAD)
                If valor <> "" Then
                    prec_especial = FormatNumber(valor, 2)
                Else
                    prec_especial = ""
                End If
            Else
                prec_especial = ""
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.obtener_precio_especial]:  grupo = {grupo} tip = {tip} cli = {cli} art = {art} cant = {cant} ", empgrupoCod, vTIP_VC, cod_cli, vGAART_COD, CANTIDAD)
            prec_especial = ""
        End Try

        Return prec_especial
    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Function gaart_es_tira_o_rollo(ByVal empgrupoCod As String, ByVal vGAART_COD As String) As String
        Dim es_tira_o_rollo As String = "N"
        Dim clasi_tira As String = ConfigurationManager.AppSettings("CLASI_TIRAS_ROLLOS")
        Try
            Dim clasi As New BCb2b.gaartclasi(empgrupoCod, vGAART_COD, clasi_tira)
            es_tira_o_rollo = clasi.prop_GACLASIF_COD

            If es_tira_o_rollo = "" Then
                es_tira_o_rollo = "N"
            End If

            '---ESTO COMENTAR CUANDO SUBAMOS A REAL, ES PARA QUE NO SALTE LA PANTALLA DE TIRAS
            'es_tira_o_rollo = "N"
            '---FIN ESTO COMENTAR CUANDO SUBAMOS A REAL
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.gaart_es_tira_o_rollo]: grupo = {grupo} art = {art} tira = {tira} ", empgrupoCod, vGAART_COD, clasi_tira)
        End Try


        Return es_tira_o_rollo

    End Function
    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> _
    Public Sub borrar_linea(ByVal empgrupoCod As String, ByVal EMCOD As String, ByVal vTIP_VC As String, ByVal vGGOFETIP_COD As String, ByVal vN_OFE As String, ByVal vN_LIN As String, ByVal vGAART_COD As String, ByVal vDESCRIP As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal PR_PRECIO As String, ByVal DESCUENTO As String, ByVal vF_ENTRPREV As String, ByVal total As String)
        Dim list_LINEAS As New List(Of BCb2b.COferta_linOff)
        Dim LINEAOFE As New BCb2b.COferta_linOff()
        Try
            If Not Session("lineasOferta") Is Nothing Then
                list_LINEAS = Session("lineasOferta")
            End If

            Dim vienedeofertaSN As Boolean = False 'revisar esto!!!!JVC!!!
            Dim ERRORCOSTE As Boolean

            Dim plazo As String = "en borrar línea"

            'ESTO ES PARA QUE NO DE ERROR AL BORRAR LA LINEA, PORQUE HAN METIDO EL CODIGO DEL ARTICULO PERO NO LA CANTIDAD.
            If CANTIDAD = "" Then
                CANTIDAD = "0"
            End If
            If PR_PRECIO = "" Then
                PR_PRECIO = "0"
            End If
            If DESCUENTO = "" Then
                DESCUENTO = "0"
            End If

            LINEAOFE = New BCb2b.COferta_linOff(ConfigurationManager.AppSettings("Grupo"), ConfigurationManager.AppSettings("Empresa"), ConfigurationManager.AppSettings("Venta"), vGGOFETIP_COD, vN_OFE, vN_LIN, vGAART_COD.ToUpper, vDESCRIP, CANTIDAD, "", PR_PRECIO, vF_ENTRPREV, Nothing, COD_CLI, DESCUENTO, plazo, vienedeofertaSN, ERRORCOSTE)
            lineas = LINEAOFE.delLinea(list_LINEAS, LINEAOFE)

            Session("lineasOferta") = lineas
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.borrar_linea]:  list_lineas = {@list_lineas} lineaofe = {@lineaofe} ", list_LINEAS, LINEAOFE)
        End Try
    End Sub
    <Ajax.AjaxMethod()>
    Public Function Obtener_Precio_UnPr(ByVal pEmpgrupoCod As String, ByVal pGaartCod As String, ByVal pPrecio As String, ByVal pCantidad As String, ByVal pEquiUnpr As String, ByVal pCulture As String) As String
        Dim resultado As String = ""
        Try
            pCantidad = GestionaNumero(pCantidad, pCulture)
            pPrecio = GestionaNumero(pPrecio, pCulture)
            pEquiUnpr = GestionaNumero(pEquiUnpr, pCulture)

            If pCantidad <> "" And pPrecio <> "" And pEquiUnpr <> "" Then
                'JCE. 03/02/2017. Si es de la familia Akustikabsorver (03) tiene que devolver el precio unitario ya que lo devuelve como UN y no como M2.
                If EsFamiliaAkustikAbsorver(pEmpgrupoCod, pGaartCod) Then
                    resultado = FormatNumber(CDbl(pPrecio), 2)
                Else
                    resultado = FormatNumber(CDbl(pPrecio) * CDbl(pCantidad) * CDbl(pEquiUnpr), 2)
                End If
            End If

        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Obtener_Precio_UnPr]: cant = {cant} idioma = {idioma} prec = {prec} ", pCantidad, pCulture, pPrecio)
        End Try

        Return resultado
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_precios(ByVal cod_Art As String, ByVal COD_CLI As String, ByVal CANTIDAD As String, ByVal v_cultura As String) As String
       ' Teniendo un código artículo, al cambiar la cantidad cargo 
        ' precios y descuentos del artículo para esa cantidad.
        If (String.IsNullOrEmpty(cod_Art)) Then
            Return ""
        End If

        Dim cliente As New BCb2b.CUsuarios()
        Try
            cod_Art = cod_Art.ToUpper
            cliente.CrearUsuario(COD_CLI)

            Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)

            CANTIDAD = GestionaNumero(CANTIDAD, v_cultura)

            If CANTIDAD <> "" Then
                Return articulo_prueba.calcula_precio_b2b(cliente, CDbl(CANTIDAD))
            End If

            Return ""
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearOferta.Obtener_precios] cli = {@cli} cant = {cant} ", cliente, CANTIDAD)
            Return ""
        End Try
    End Function
    <Ajax.AjaxMethod()> _
    Public Function Obtener_descuento(ByVal cod_Art As String, ByVal cod_cli As String, ByVal cantidad As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo, al cambiar la cantidad cargo 
        ' precios y descuentos del artículo para esa cantidad.
        If (String.IsNullOrEmpty(cod_Art)) Then
            Return ""
        End If

        If (String.IsNullOrEmpty(cantidad)) Then
            Return FormatNumber("0", 2)
        End If

        Dim DTO As String = ""
        Dim cliente As New BCb2b.CUsuarios()
        Try
            cantidad = GestionaNumero(cantidad, v_cultura)

            If cantidad <> "" Then
                cod_Art = cod_Art.ToUpper
                cliente.CrearUsuario(cod_cli)
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)

                Return articulo_prueba.dame_porcentaje_dto_b2b(cliente, CDbl(cantidad), Nothing, Nothing)
            End If

            Return ""
        Catch ex As Exception
            Log.Error(ex, "[Ajax:CrearOferta.Obtener_descuento] cli = {@cli} cant = {cant} ", cliente, cantidad)
            Return ""
        End Try
    End Function
    <Ajax.AjaxMethod()> _
    Public Function calcular_total_NP(ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo y una cantidad. Al cambiar el precio
        ' recalculo el total (No hace falta query contra la bd)

        If (descuento = "") Then
            descuento = FormatNumber("0", 2)
        End If

        cantidad = GestionaNumero(cantidad, v_cultura)
        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If (cantidad <> "" And precio <> "" And descuento <> "") Then
            Dim total As String = ""
            Try
                total = FormatNumber((precio * cantidad) - ((precio * cantidad) * (descuento / 100)), 2)
            Catch ex As Exception
                Log.Error(ex, "[Ajax:CrearOferta.calcular_total_NP] prec = {prec} cant = {cant} desc = {desc} idioma = {idioma} ", precio, cantidad, descuento, v_cultura)
            End Try

            Return total
        Else
            Return FormatNumber("0", 2)
        End If
    End Function
    <Ajax.AjaxMethod()> _
    Public Function calcular_total_ND(ByVal cantidad As String, ByVal precio As String, ByVal descuento As String, ByVal v_cultura As String) As String
        ' Teniendo un código artículo, una cantidad y un precio.
        ' Al cargar el descuento recalculo el total. (No hace falta query contra bd)
        If (descuento = "") Then
            descuento = FormatNumber("0", 2)
        End If

        cantidad = GestionaNumero(cantidad, v_cultura)
        precio = GestionaNumero(precio, v_cultura)
        descuento = GestionaNumero(descuento, v_cultura)

        If (cantidad <> "" And precio <> "" And descuento <> "") Then
            Dim precio_aux As String = ""
            Try
                precio_aux = (precio * cantidad) - ((precio * cantidad) * (descuento / 100))
            Catch ex As Exception
                Log.Error(ex, "[CrearOferta.calcular_total_ND] cant = {cant} prec = {prec} desc = {desc} idioma = {idioma} ", cantidad, precio, descuento, v_cultura)
            End Try

            'precio_aux = Replace(precio_aux, ",", ".")
            Return FormatNumber(precio_aux, 2)

        Else
            Return FormatNumber("0", 2)
        End If
    End Function
    <Ajax.AjaxMethod()>
    Public Function Obtener_DescripArt(ByVal cod_Art As String) As String
        cod_Art = cod_Art.ToUpper
        If (cod_Art <> "") Then
            Try
                Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art)
                If articulo_prueba.prop_cod <> "" Then
                    If (articulo_prueba.prop_descrip <> "Null") Then
                        Return articulo_prueba.prop_descrip
                    Else
                        Return " "
                    End If
                Else
                    Return "Invalid article"
                End If

            Catch ex As Exception
                Log.Error(ex, "[CrearOferta.Obtener_DescripArt] art = {art} ", cod_Art)
                Return "Invalid article"
            End Try
        Else
            Return " "
        End If

    End Function
    <Ajax.AjaxMethod()>
    Public Function Obtener_CodigoArtRef(ByVal cod_cli As String, ByVal cod_Ref As String) As String
        'cod_Ref = cod_Ref.ToUpper

        'en v_codigo_idioma nos llega la cultura. tenemos que obtener el idiomas.
        Dim idioma As New BCb2b.idiomas()
        If (cod_Ref <> "") Then
            Try
                Dim articulo_ref As New BCb2b.CArticulo()
                Dim cod_art As String = articulo_ref.articulo_con_ref(cod_cli, cod_Ref)
                'If (cod_art <> "") Then
                '    Dim articulo_de_ref As New BCb2b.CArticulo(cod_art)
                'Else : Return "NO"
                'End If
                Return cod_art

            Catch ex As Exception
                Log.Error(ex, "[CrearOferta.Obtener_CodigoArtRef]: cli = {cli} ref = {ref} ", cod_cli, cod_Ref)

                Return "Invalid article"
            End Try
        Else
            Return ""
        End If

    End Function
    <Ajax.AjaxMethod()>
    Public Function Obtener_DescripArtIdioma(ByVal cod_Art As String, ByVal vggobstip_cod As String, ByVal vcodigo_idioma As String) As String
        cod_Art = cod_Art.ToUpper

        'NO PERMITIMOS INTRODUCIR EL ARTICULO PARA COMISIONES.
        Dim param As New BCb2b.CParametros()
        If cod_Art = param.dame_param("B2B_ART_COMI_AGENTES") Then
            Return "Invalid article"
        Else

            'en v_codigo_idioma nos llega la cultura. tenemos que obtener el idiomas.
            Dim idioma As New BCb2b.idiomas()
            idioma.dameIdioma(vcodigo_idioma)
            If (cod_Art <> "") Then
                Try
                    Dim articulo_prueba As New BCb2b.CArticulo(ConfigurationManager.AppSettings("grupo"), cod_Art.ToUpper)
                    Dim dd As String = articulo_prueba.descripcion_idiomas(vggobstip_cod, idioma.prop_idioma, ConfigurationManager.AppSettings("ING_SPYRO"))
                    If dd <> "" Then
                        If (dd <> "Null") Then
                            Return dd
                        Else
                            Return articulo_prueba.prop_descrip
                        End If
                    Else
                        Return "Invalid article"
                    End If

                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.Obtener_DescripArtIdioma]: art = {art} cod_obs = {cod_obs} idi = {idi} ", cod_Art, vggobstip_cod, idioma.prop_idioma)
                    Return "Invalid article"
                End Try
            Else
                Return ""
            End If
        End If

    End Function
    <Ajax.AjaxMethod()>
    Public Function usuarioValido(ByVal usrnom As String, ByVal usrpass As String, ByVal Sesion_usuario As String) As String
        Dim Usuario As New BCb2b.CUsuarios(usrnom,
                                           usrpass,
                                           ConfigurationManager.AppSettings("grupo"),
                                           ConfigurationManager.AppSettings("Venta"),
                                           ConfigurationManager.AppSettings("usrnom"),
                                           ConfigurationManager.AppSettings("usrpass"))
        If Not Usuario.es_vacio() Then
            If (Usuario.prop_LOGIN.CompareTo(Sesion_usuario) = 0) Then
                'If (Usuario.prop_LOGIN.CompareTo("CELMA") = 0) Then

                Return "S"
            Else
                Return "N"
            End If
        Else
            Return "N"
        End If
        Return "S"

    End Function
    'FIN METODOS AJAX

    'LLAMADAS A LOVS
    Public Shared Sub OpenPopUp(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal PagePath As String, ByVal windowName As String, ByVal width As Integer, ByVal height As Integer)
        Dim clientScript As String
        Dim windowAttribs As String
        windowAttribs = "width=" & width & "px," & _
                    "height=" & height & "px," & _
                    "left='+((screen.width -" & width & ") / 2)+'," & _
                    "top='+ (screen.height - " & height & ") / 2+'"
        clientScript = "window.open('" & PagePath & "','" & windowName & "','" & windowAttribs & "');return false;"
        opener.Attributes.Add("onClick", clientScript)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.Label, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub
    Public Shared Sub ShowLupaArticulo(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        OpenPopUp(opener, "lov_articulos.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub
    Public Shared Sub ShowLupaSuRef(ByVal opener As System.Web.UI.WebControls.WebControl, ByVal artControl As System.Web.UI.WebControls.TextBox, ByVal lblDescripART As System.Web.UI.WebControls.TextBox, ByVal surefControl As System.Web.UI.WebControls.TextBox, ByVal art_cantControl As System.Web.UI.WebControls.TextBox)
        OpenPopUp(opener, "lov_su_ref.aspx?textbox=" & artControl.ClientID & "&textbox2=" & lblDescripART.ClientID & "&textbox3=" & surefControl.ClientID & "&textbox4=" & art_cantControl.ClientID, "LOV", 410, 630)
    End Sub
    'FIN LLAMADAS A LOVS

    'FUNCIONES
    Public Sub AddNewRow(ByVal sender As Object, ByVal e As GridViewRowEventArgs, ByVal n_lin As Integer, ByVal textoMensaje As String, ByVal clasecss As String)
        Try
            Dim GridView1 As GridView = DirectCast(sender, GridView)
            Dim NewTotalRow As New GridViewRow(0, 0, DataControlRowType.DataRow, DataControlRowState.Insert)
            NewTotalRow.Font.Bold = True
            NewTotalRow.BackColor = System.Drawing.Color.Aqua
            Dim HeaderCell As New TableCell()
            HeaderCell.Height = 10
            HeaderCell.HorizontalAlign = HorizontalAlign.Center
            HeaderCell.Text = textoMensaje
            HeaderCell.ColumnSpan = 10
            HeaderCell.CssClass = clasecss
            NewTotalRow.Cells.Add(HeaderCell)
            GridView1.Controls(0).Controls.AddAt(e.Row.RowIndex + n_lin + 1, NewTotalRow)
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.AddNewRow] lin = {lin} ", n_lin + 1)
        End Try
    End Sub
    Private Sub CargarDireccionesEnvio(ByVal pGgclipr As BCb2b.ggclipr, ByVal pConexion As String)
        Dim vDirEnv As New BCb2b.CDirecciones()
        Dim vListDirEnv As New ArrayList
        vListDirEnv = vDirEnv.LISTA_DIRECCIONES(pGgclipr.prop_RSOCIAL_COD, pConexion)
        DDLDir_Envio.DataSource = vListDirEnv
        DDLDir_Envio.DataTextField = "PROP_NOMBRE_DIR"
        DDLDir_Envio.DataValueField = "PROP_COD"
        DDLDir_Envio.DataBind()

        'JCE. Si no tiene direccion de envio por defecto, ponemos la social.
        Dim dir_defecto As New BCb2b.CDirecciones()
        If pGgclipr.prop_RSOCDIR_ENV <> "" Then
            dir_defecto = pGgclipr.PROP_DIR_ENVIO
        Else
            dir_defecto = pGgclipr.PROP_DIR_social
        End If
        DDLDir_Envio.SelectedValue = dir_defecto.PROP_COD

        Try

            lbldir.Text = dir_defecto.PROP_DIR
            lblCP.Text = dir_defecto.PROP_COD_POSTAL
            lblProvi.Text = dir_defecto.PROP_PROVI_NOM
            lblTfono.Text = dir_defecto.PROP_TELEFONOS
            Dim uti As New BCb2b.Utilities()
            If uti.IsMobileBrowser() = True Then
                lblTfono.NavigateUrl = uti.DameMailtoTelefono(dir_defecto.PROP_TELEFONOS())
                lblTfono.CssClass = ""
            Else
                lblTfono.NavigateUrl = ""
                lblTfono.CssClass = "HyperlinkSinStyles"
            End If

            lblPoblacion.Text = dir_defecto.PROP_POBLAC_NOM
            lblpais.Text = dir_defecto.PROP_PAISES_nom
            lblFax.Text = dir_defecto.PROP_TELEFAX

        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.Cargando datos direccion] dir = {@dir} ", dir_defecto)
        End Try
    End Sub
    Private Sub GestionarCalculosAsociados(ByVal pCabecera As BCb2b.COferta_Cab)
        Dim listado_calculos As New ArrayList
        listado_calculos = pCabecera.prop_LISTADO_IDDISTRIBUCION

        If listado_calculos.Count > 0 Then
            Dim ggestcampa_cod As String = ""
            lblCalculoAsoc.Text = ""
            For Each calculo As AMC_Proyectos_pkg.CCalculos In listado_calculos
                ggestcampa_cod = calculo.prop_idestudio.PadLeft(10, "0")
                Dim revision As String = calculo.prop_revision
                Dim observacion As String = calculo.prop_observaciones

                lblCalculoAsoc.Text = lblCalculoAsoc.Text & observacion & ","
            Next
            lblCalculoAsoc.Text = lblCalculoAsoc.Text.Remove(lblCalculoAsoc.Text.LastIndexOf(","))
            lblCalculoAsoc.Text = ggestcampa_cod & " (" & lblCalculoAsoc.Text & ")"

            If ggestcampa_cod <> "" Then
                pCabecera.prop_LISTADO_IDDISTRIBUCION = listado_calculos
            Else
                lblcalcasoctitu.Visible = False
                lblCalculoAsoc.Visible = False
            End If

            lblatencion_confim_calc.Visible = True
            div_lblatencion_confim_calc.Visible = True
            lblatencion_confim_calc.Text = GetLocalResourceObject("lblAtenConfirCalc")
            If lblCalculoAsoc.Text <> "" Then
                lblatencion_confim_calc.Text = lblatencion_confim_calc.Text & " " & lblCalculoAsoc.Text
            End If
        Else
            lblcalcasoctitu.Visible = False
            lblCalculoAsoc.Visible = False
            lblatencion_confim_calc.Visible = False
            div_lblatencion_confim_calc.Visible = False
            lblatencion_confim_calc.Text = ""
        End If
    End Sub
    Private Sub CargarDatosCabecera(ByRef pCabecera As BCb2b.COferta_Cab)
        pCabecera.prop_dir_envio = New BCb2b.CDirecciones(pCabecera.prop_rsocial_cod, DDLDir_Envio.SelectedValue)
        pCabecera.prop_ggofetip_cod = DDLSeries.SelectedValue
        tboxRefCli.Text = pCabecera.prop_su_ref_OFE
        tboxAtte.Text = pCabecera.prop_ATTE
        txtarea_observacion.Text = pCabecera.prop_OBSERVACION_dEFECTO
        txtarea_observacion_pie.Text = pCabecera.prop_OBSERVACION_pie

        Dim dir_sel As New BCb2b.CDirecciones()
        dir_sel = pCabecera.prop_dir_envio
        DDLDir_Envio.SelectedValue = dir_sel.PROP_COD
        comboModosEnvio.SelectedValue = pCabecera.prop_GGMENVIO_COD

        lbldir.Text = dir_sel.PROP_DIR
        lblCP.Text = dir_sel.PROP_COD_POSTAL
        lblProvi.Text = dir_sel.PROP_PROVI_NOM
        lblTfono.Text = dir_sel.PROP_TELEFONOS
        lblPoblacion.Text = dir_sel.PROP_POBLAC_NOM
        lblpais.Text = dir_sel.PROP_PAISES_nom
        lblFax.Text = dir_sel.PROP_TELEFAX
    End Sub
    Private Sub CargarModosEnvio(ByVal pEmpgrupoCod As String, ByVal pConexion As String, Optional ByVal pMEnvioDef As String = "", Optional ByVal pIdioma As String = "")
        Dim vGgclipr As New BCb2b.ggclipr()
        Dim vGvagente As New BCb2b.gvagente()
        Try
            comboModosEnvio.Items.Clear()
            Dim vListaModosEnvio As New ArrayList
            Dim vArrayModosEnvio As Array

            'LOS MODOS DE ENVIO SE OBTIENEN UNA OBSERVACION ASOCIADA A LA FICHA DEL PROVEEDOR (OBME)
            vGgclipr = Session("cliente")
            If Not Session("agente") Is Nothing Then
                vGvagente = Session("agente")
            Else
                vGvagente = New BCb2b.gvagente(vGgclipr.prop_GVAGENTE_COD, pEmpgrupoCod, 0)
            End If

            Dim vGgcliprobs As New BCb2b.GGCLIPROBS()
            Dim vValor As String = vGgcliprobs.DameObserAGEdeGGCLIPR(pEmpgrupoCod, vGvagente, vGgclipr.prop_COD, ConfigurationManager.AppSettings("OBME"), pConexion)

            Dim vTieneGgmenvioDef As Boolean = False
            If vValor <> "" Then
                vArrayModosEnvio = Split(vValor, ",")

                Dim i As Integer = 0
                For i = 0 To vArrayModosEnvio.Length - 1

                    Dim vGgmenvio As New BCb2b.CGGMenvio()
                    If pIdioma <> "" Then
                        vGgmenvio.DameDatosModoEnvio(vArrayModosEnvio(i), pIdioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                    Else
                        vGgmenvio = New BCb2b.CGGMenvio(vArrayModosEnvio(i))
                    End If

                    If vGgmenvio.PROP_cod = pMEnvioDef Then
                        vTieneGgmenvioDef = True
                    End If

                    vListaModosEnvio.Add(vGgmenvio)
                Next i
            Else
                '--------AMC_NE183. Si no hay observacion de proveedor OBME poner A Convenir POR DELANTE
                Dim mEnvio As New BCb2b.CGGMenvio()
                If pIdioma <> "" Then
                    mEnvio.DameDatosModoEnvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"), pIdioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                Else
                    mEnvio = New BCb2b.CGGMenvio(ConfigurationManager.AppSettings("MODO_ENVIO_A_CONVENIR"))
                End If
                vListaModosEnvio.Add(mEnvio)
                '------FIN AMC_NE183-------

                If pMEnvioDef <> "" Then
                    Dim MEnvioDefecto As New BCb2b.CGGMenvio()
                    MEnvioDefecto.DameDatosModoEnvio(pMEnvioDef, pIdioma, ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGMENVIO"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGMENVIO"), pConexion)
                    vListaModosEnvio.Add(MEnvioDefecto)
                    vTieneGgmenvioDef = True
                End If
            End If

            If vTieneGgmenvioDef = False Then
                Dim vMEnvioDef As New BCb2b.CGGMenvio(pMEnvioDef)
                vListaModosEnvio.Add(vMEnvioDef)
            End If

            comboModosEnvio.DataSource = vListaModosEnvio
            comboModosEnvio.DataTextField = "prop_descrip"
            comboModosEnvio.DataValueField = "prop_cod"
            comboModosEnvio.DataBind()
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.cargarListadoModosEnvio] age = {@age} cli = {@cli} ", vGvagente, vGgclipr)
        End Try

    End Sub
    Private Sub guardar_info_cabecera()
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        Dim vCabecera As New BCb2b.COferta_Cab()
        Dim vGgclipr As New BCb2b.ggclipr()
        Try
            'RECARGAMOS DATOS DE REF,ATT,OBSERS Y DIR PARA GUARDARLO Y QUE NO SE PIERDA
            vCabecera = Session("cabecera")
            vCabecera.prop_dir_envio = New BCb2b.CDirecciones(lblRSocial.Text, DDLDir_Envio.SelectedValue, vConexion)
            vCabecera.prop_GGMENVIO_COD = comboModosEnvio.SelectedValue
            vCabecera.prop_ATTE = tboxAtte.Text
            vCabecera.prop_su_ref_OFE = tboxRefCli.Text
            vCabecera.prop_OBSERVACION_dEFECTO = txtarea_observacion.Text
            vCabecera.prop_OBSERVACION_pie = txtarea_observacion_pie.Text
            vCabecera.prop_ggofetip_cod = DDLSeries.SelectedValue

            vGgclipr = Session("cliente")

            'AMC_NE243. JCE. 07/06/16. FPAGO OFERTAS INGENIERO.
            Dim vPerfiles As New BCb2b.USUARIOS_B2B()
            vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))
            Dim vFPago As String = ""
            If vPerfiles.prop_TIPO_PERFIL = 0 Then 'ING o SVT
                vFPago = ddlFPago.SelectedValue
                vCabecera.prop_RSOCCONDI_COD = ""
            Else
                '-----CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT
                '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
                Dim vParam As New BCb2b.CParametros()
                If vGgclipr.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Or vGgclipr.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoPC") Then
                    vFPago = vParam.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"), vConexion)
                    vCabecera.prop_RSOCCONDI_COD = ""
                Else
                    vFPago = vGgclipr.prop_forma_pago.PROP_COD
                    vCabecera.prop_RSOCCONDI_COD = vGgclipr.prop_RSOCCONDI_DEF
                End If
            End If
            vCabecera.prop_FORMA_DE_PAGO = vFPago
            '-----FIN AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
            '-----FIN CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT

            'Calculos asociado, si por lo que sea a perdido los calculos miramos si tiene.
            Dim vListadoCalculos As New ArrayList
            vListadoCalculos = vCabecera.prop_LISTADO_IDDISTRIBUCION
            If vListadoCalculos.Count = 0 Then
                Dim vCalc As New AMC_Proyectos_pkg.CCalculos()
                vListadoCalculos = vCalc.DameCalculosDeOferta(vCabecera.prop_EMPGRUPO_COD, vCabecera.prop_emp_cod, vCabecera.prop_tip_Vc, vCabecera.prop_ggofetip_cod, vCabecera.prop_N_OFE, vCabecera.prop_N_REVISION)
                vCabecera.prop_LISTADO_IDDISTRIBUCION = vListadoCalculos
            End If

            Session("cabecera") = vCabecera
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.guardar_info_cabecera] cab_ofe = {@cab_ofe} ", vCabecera)
        End Try

    End Sub
    Private Sub GestionarFormasPago(ByVal pEmpgrupoCod As String, ByVal cli As BCb2b.ggclipr, ByVal f_pago_cli As String, ByVal pConexion As String)
        'AMC_NE243. JCE. 06/06/2016. FORMA DE PAGO INGENIEROS.
        Dim vPerfiles As New BCb2b.USUARIOS_B2B()
        vPerfiles.Administrar_Permisos_Perfiles(Session("perfil_usuario"))

        If vPerfiles.prop_TIPO_PERFIL = 0 Then 'SVT o ING
            'CARGAMOS EL COMBO DE FORMAS DE PAGO DE LA FICHA DEL AGENTE E INTRODUCIMOS LA DE A CONVENIR.
            Dim vGvagente As New BCb2b.gvagente(cli.prop_GVAGENTE_COD, pEmpgrupoCod, 0)
            Dim vObsProveedor As New BCb2b.GGCLIPROBS(pEmpgrupoCod, ConfigurationManager.AppSettings("compra"), vGvagente.prop_GGCLIPR_PROV, ConfigurationManager.AppSettings("OBFP"), pConexion)
            Dim vValor As String = vObsProveedor.PROP_COMENTARIO

            Dim vListadoFPago As New ArrayList
            Dim vArrayFPago As Array
            ddlFPago.Items.Clear()

            If vValor <> "" Then
                vArrayFPago = Split(vValor, ",")
                Dim i As Integer = 0
                For i = 0 To vArrayFPago.Length - 1
                    Dim vFPago As New BCb2b.CFPago()
                    If Session("idioma_spyro") <> "" Then
                        vFPago.DameDatosFPago(vArrayFPago(i), Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"), pConexion)
                    Else
                        vFPago = New BCb2b.CFPago(vArrayFPago(i), pConexion)
                    End If
                    vListadoFPago.Add(vFPago)
                Next i
            End If

            'SI NO HAY NINGUNA FORMA DE PAGO, PONEMOS LA DE A CONVENIR Y LA DEL CLIENTE.
            If vListadoFPago.Count = 0 Then
                Dim vParam As New BCb2b.CParametros()
                Dim vFPagoCod As String = vParam.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"), pConexion)

                Dim vFPago As New BCb2b.CFPago()
                vFPago.DameDatosFPago(vFPagoCod, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"), pConexion)
                vListadoFPago.Insert(0, vFPago)

                Dim vFpPagoCli As New BCb2b.CFPago()
                vFpPagoCli.DameDatosFPago(cli.prop_forma_pago.PROP_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"), pConexion)
                vListadoFPago.Insert(0, vFpPagoCli)
            End If

            ddlFPago.DataSource = vListadoFPago
            ddlFPago.DataTextField = "prop_descrip"
            ddlFPago.DataValueField = "prop_cod"

            ddlFPago.Visible = True
            lblFormadepago.Visible = False
        Else
            'LO HABITUAL
            Dim vFPago As New BCb2b.CFPago()
            vFPago.DameDatosFPago(f_pago_cli, Session("idioma_spyro"), ConfigurationManager.AppSettings("TRADUC_FPAGO_IDIOMASTAB"), pConexion)
            lblFormadepago.Text = vFPago.PROP_DESCRIP
            ddlFPago.Visible = False
            lblFormadepago.Visible = True
        End If
        ddlFPago.DataBind()
    End Sub
    Private Function ObtenerSeriesOferta(ByVal pEmpgrupoCod As String, ByVal pTipVc As String, ByVal pConexion As String) As ArrayList 'ESTÁNDAR
        Dim vParam As New BCb2b.CParametros()
        Dim vSeriesOfe As String = vParam.dame_param(ConfigurationManager.AppSettings("SERIES_OFE_CRE"), pConexion)
        Dim vGgofetip As New BCb2b.CGGOfetip()
        Dim vListado As ArrayList = vGgofetip.listado_SerieOferta(pEmpgrupoCod, pTipVc, vSeriesOfe, "", "", "", pConexion, Session("idioma_spyro"))
        Return vListado
    End Function
    Private Function EsFamiliaAkustikAbsorver(ByVal pEmpgrupoCod As String, ByVal pGaartCod As String, Optional ByVal pConexion As String = "") As Boolean
        Dim vGaartClasi As New BCb2b.gaartclasi(pEmpgrupoCod, pGaartCod, ConfigurationManager.AppSettings("CLA_FAMILIA"), pConexion)
        Dim vFamilia As String = vGaartClasi.prop_GACLASIF_COD
        Dim vEsFamilia03 As Boolean = (vFamilia = "03") 'Akustikabsorver
        Return vEsFamilia03
    End Function
    'FIN FUNCIONES

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Ajax.Utility.RegisterTypeForAjax(GetType(CrearOferta))

        Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
        Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
        Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)

        'HABILITAMOS LOS MENSAJES MODALES
        Dim vUti As New BCb2b.Utilities
        vUti.HabilitarModalMessages(Me, GetLocalResourceObject("MsgModalBtnAceptar"))
        vUti.CrearModalConfirm(Me, "BorrarLineaOferta", GetLocalResourceObject("MsgModalBtnConfirm"), GetLocalResourceObject("lblResourceBorrarLineaConfirm.Text"), GetLocalResourceObject("MsgModalBtnYes"), GetLocalResourceObject("MsgModalBtnNo"), False)

        If (Session("cliente") Is Nothing) Then
            Server.Transfer("BusquedaClientes.aspx")
        End If

        'Cargamos hiddens.
        tboxGrupo.Value = vEmpgrupoCod
        tboxempresa.Value = vEmpCod
        tboxggofetip_cod.Value = DDLSeries.SelectedValue

        Session("N_OFE") = ""
        Session("GRUPO_OFE") = ""
        Session("EMPRESA_OFE") = ""
        Session("TIPO_OFE") = ""

        btnContinuar.Visible = True

        Me.num_lineas_error_costo = 0

        Dim vListaSeries As ArrayList = ObtenerSeriesOferta(vEmpgrupoCod, vTipVc, vConexion) 'Estándar
        DDLSeries.DataSource = vListaSeries
        DDLSeries.DataBind()

        'RECALCULAMOS PARA VER SI HA CAMBIADO LA DIRECCION DE ENVIO POR DEFECTO.
        Dim vGgclipr As New BCb2b.ggclipr()
        vGgclipr = Session("cliente")
        Dim vGgcliprAux As New BCb2b.ggclipr(vGgclipr.prop_COD, vGgclipr.prop_EMPGRUPO_COD, vGgclipr.prop_TIP_VC, vConexion)
        vGgclipr = vGgcliprAux
        Session("cliente") = vGgclipr
        'FIN RECALCULAMOS PARA VER SI HA CAMBIADO LA DIRECCION DE ENVIO POR DEFECTO.

        If Not Page.IsPostBack Then
            CargarDireccionesEnvio(vGgclipr, vConexion) 'Direccion de envío
            CargarModosEnvio(vEmpgrupoCod, vConexion, vGgclipr.prop_GGMENVIO_COD, Session("idioma_spyro")) 'Modos de envío
        End If

        Dim vGvagenteCod As OracleNumber = OracleNumber.Null
        If Not Session("agente") Is Nothing Then
            vGvagenteCod = CInt(Session("agente").prop_cod.ToString)
        End If

        lblSerie.Text = DDLSeries.SelectedItem.Value()
        lblSerie.Visible = False
        DDLSeries.Visible = True

        '-----CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT
        '-----AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
        Dim vParam As New BCb2b.CParametros()
        Dim vFPagoCod As String = ""
        If vGgclipr.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Or vGgclipr.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoPC") Then
            vFPagoCod = vParam.dame_param(ConfigurationManager.AppSettings("AMC_B2B_OBFP_OFERTAS"), vConexion)
        Else
            vFPagoCod = vGgclipr.prop_forma_pago.PROP_COD
        End If
        '-----FIN AMC_NE183----- FORMA DE PAGO DE PARAMETRO 
        '-----FIN CAMBIO AMC_NE213. LA FORMA DE PAGO PDTE PARA LAS OFERTAS SOLO PARA CLIENTES EN ESTADO PC O POT

        Dim vCabecera As New BCb2b.COferta_Cab()
        If (Session("cabecera") Is Nothing) Then
            vCabecera = New BCb2b.COferta_Cab(vGgclipr, vEmpCod, DDLSeries.SelectedItem.Value, ConfigurationManager.AppSettings("ESTADO_ACTIVO"), ConfigurationManager.AppSettings("imprimir_sn"), ConfigurationManager.AppSettings("historico_sn"), vGvagenteCod.ToString, tboxRefCli.Text, tboxAtte.Text, DDLDir_Envio.SelectedValue, "", vFPagoCod, Nothing)
            Session("cabecera") = vCabecera
        End If

        If Not (Page.IsPostBack) Then
            If Not (Session("cabecera") Is Nothing) Then
                vCabecera = Session("cabecera")
                CargarDatosCabecera(vCabecera)
                GestionarCalculosAsociados(vCabecera)
                GestionarFormasPago(vEmpgrupoCod, vGgclipr, vFPagoCod, vConexion)
                Session("cabecera") = vCabecera
            End If
        End If

        Try
            If (Not Session("cliente") Is Nothing) Then
                vGgclipr = Session("cliente")

                'AMC_NE127. SI NO TIENE TODAS LAS CLASIS METIDAS O ESTA EN ESTADO POT POR LO QUE SEA, VA A CREARCLIENTE
                Dim vClasisOblis As String = vParam.dame_param(ConfigurationManager.AppSettings("B2B_CLASIS_OBLI_USU_CREACLI"), vConexion)
                Dim vGgcliclasi As New BCb2b.CGGCLICLASI()
                Dim vTodasLlenas As Boolean = vGgcliclasi.CompruebaSiClasisObliRellenas(vEmpgrupoCod, vTipVc, vClasisOblis, vGgclipr.prop_COD, Session("idioma_spyro"), ConfigurationManager.AppSettings("NOMTABLA_TRADUC_GGCLATIP"), ConfigurationManager.AppSettings("NOMCOLUMNA_TRADUC_GGCLATIP_DESC"), vConexion)

                Dim vPerfiles As New BCb2b.USUARIOS_B2B()
                vPerfiles.Administrar_Permisos_Perfiles(Session("tipo_usuario"))

                If vPerfiles.prop_TIPO_PERFIL <> 0 Then 'SI ES ING O SVT QUE NO LE MANDE A RELLENAR CLASIS O CONTACTO. PORQUE SINO AL PASAR DE CALCULO A OFERTA LE FASTIDIA.
                    If vTodasLlenas = False Or vGgclipr.prop_GGESTADO_COD = ConfigurationManager.AppSettings("EstadoNewCli") Then
                        Session("new_cliente") = vGgclipr
                        Response.Redirect("CrearCliente.aspx")
                    End If
                End If

                'Datos de la cabecera fijos
                lblNombreCli.Text = vGgclipr.prop_NOMBRE
                lblRSocial.Text = vGgclipr.prop_RSOCIAL_COD
                lblFOFE.Text = Now().Date
                lblSerie.Text = vCabecera.prop_ggofetip_Desc()
                DDLSeries.SelectedValue = vCabecera.prop_ggofetip_cod
                lblNOferta.Text = vCabecera.prop_N_OFE

                Session("N_OFE") = vCabecera.prop_N_OFE
                Session("GRUPO_OFE") = vCabecera.prop_EMPGRUPO_COD
                Session("EMPRESA_OFE") = vCabecera.prop_emp_cod
                Session("TIPO_OFE") = vCabecera.prop_ggofetip_cod

                If (txtarea_observacion_pie.Text = "") Then
                    If Not (Page.IsPostBack) Then
                        Dim vIdiomaSpyro As String = Session("idioma_spyro")
                        Dim vObsIdioma As String = "O" + vIdiomaSpyro

                        Dim vCodProveedor As String = ""
                        Dim vGvagente As New BCb2b.gvagente()
                        If Not Session("agente") Is Nothing Then
                            vGvagente = Session("agente")
                            vCodProveedor = vGvagente.prop_GGCLIPR_PROV
                        Else
                            'SINO HAY AGENTE LO COGE DEL CLIENTE PARA OBTENER SUS OBSERVACIONES.
                            vGvagenteCod = vGgclipr.prop_GVAGENTE_COD
                            If vGgclipr.prop_GVAGENTE_COD <> "" Then
                                vGvagente = New BCb2b.gvagente(vGvagenteCod.ToString, vEmpgrupoCod, 0)
                                vCodProveedor = vGvagente.prop_GGCLIPR_PROV
                            End If
                        End If

                        Dim ggcliprobs As New BCb2b.GGCLIPROBS(vEmpgrupoCod, ConfigurationManager.AppSettings("compra"), vCodProveedor, vObsIdioma)
                        txtarea_observacion_pie.Text = ggcliprobs.PROP_COMENTARIO
                    End If
                End If

                'HAY QUE LLAMAR PARA CALCULAR PARAMETROS DE CABECERA 
                guardar_info_cabecera()
            End If
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.CargandoDatosCli] cliente = {@cliente} ", vGgclipr)
            LBLERROR.Text = ex.ToString
        End Try

    End Sub

    'GESTION DE LINEAS DEL BULKEDITOR
    Protected Sub BulkEditGridView1_RowDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs) Handles BulkEditGridView1.RowDataBound
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            'CONTROLES
            Dim tboxCodigoArt As TextBox
            Dim tboxSuRef As TextBox
            Dim tboxDescripART As TextBox
            Dim tboxGaartCod As TextBox
            Dim lblborrar As IButtonControl
            Dim lblf_disponible As Label
            Dim lblDisponibilidad As Label
            Dim lblGaartCod As Label
            Dim lblSuRef As Label
            Dim lblprecio_teorico As Label
            Dim lblDescripART As System.Web.UI.WebControls.Label
            Dim ibLupaArt As ImageButton
            Dim ibLupaSuRef As ImageButton
            Dim imgBorrar As Image
            Dim lblPrecio As Label
            Dim lblDescuento As Label
            Dim lbltotal As Label
            Dim Unidad As Label
            Dim lblModif As HiddenField
            Dim HfModificado As New HiddenField
            Dim lblNLin As New Label
            Dim HFLINEA As HiddenField
            Dim tbox_precio As TextBox
            Dim tbox_dto As TextBox
            Dim tboxPlazo As TextBox
            Dim tbox_cantidad As TextBox
            Dim lblAncho As Label
            Dim lblLargo As Label
            Dim lblTiras As Label
            Dim lblRollos As Label
            Dim lblM2 As Label
            Dim lblEquiUnPr As Label
            Dim lblDesperdicio As Label
            Dim imgEditTirasRollos As Image
            'FIN CONTROLES

            'BUSCAMOS CONTROLES
            tboxCodigoArt = e.Row.FindControl("tboxGaartCod")
            tboxSuRef = e.Row.FindControl("tboxSuRef")
            tboxDescripART = e.Row.FindControl("descrip_art")
            lblDescripART = e.Row.FindControl("lbldescrip_art")
            lblf_disponible = e.Row.FindControl("lblf_disponible")
            lblDisponibilidad = e.Row.FindControl("lblDisponibilidad")
            tboxGaartCod = e.Row.FindControl("tboxGaartCod")
            lblGaartCod = e.Row.FindControl("lblGaartCod")
            lblSuRef = e.Row.FindControl("lblSuRef")
            lblprecio_teorico = e.Row.FindControl("lblprecio_teorico")
            tboxPlazo = e.Row.FindControl("plazo")
            lblPrecio = e.Row.FindControl("lblPrecio")
            tbox_precio = e.Row.FindControl("tbox_precio")
            lblDescuento = e.Row.FindControl("lbldto")
            tbox_dto = e.Row.FindControl("tbox_dto")
            lbltotal = e.Row.FindControl("lblPrecio_final")
            ibLupaArt = e.Row.FindControl("IBarticulo")
            ibLupaSuRef = e.Row.FindControl("IBsuref")
            imgBorrar = e.Row.FindControl("imgBorrar")
            lblborrar = e.Row.FindControl("lbBorrar")
            lblModif = e.Row.FindControl("HfModificado")
            HFLINEA = e.Row.FindControl("HFLINEA")
            Unidad = e.Row.FindControl("lblUnidad")
            tbox_cantidad = e.Row.FindControl("tbox_cantidad")
            lblAncho = e.Row.FindControl("lblAncho")
            lblLargo = e.Row.FindControl("lblLargo")
            lblTiras = e.Row.FindControl("lblTiras")
            lblRollos = e.Row.FindControl("lblRollos")
            lblM2 = e.Row.FindControl("lblM2")
            lblEquiUnPr = e.Row.FindControl("lblEquiUnPr")
            lblDesperdicio = e.Row.FindControl("lblDesperdicio")
            imgEditTirasRollos = e.Row.FindControl("imgEditTirasRollos")
            'FIN BUSCAMOS CONTROLES

            Dim vEmpgrupoCod As String = ConfigurationManager.AppSettings("grupo")
            Dim vEmpCod As String = ConfigurationManager.AppSettings("empresa")
            Dim vTipVc As String = ConfigurationManager.AppSettings("venta")
            Dim vConexion As String = Conexion.GenerarStringConexion(Me)
            Dim vTipoUsuario As String = Session("tipo_usuario")
            Dim vGgcliprCod As String = Session("cliente").prop_cod
            Dim vObstipArtIdiomas As String = ConfigurationManager.AppSettings("obstip_articulo_idiomas")
            Dim vGaartESP As String = ConfigurationManager.AppSettings("COD_GAART_ESP")
            Dim vCabecera As New BCb2b.COferta_Cab()
            vCabecera = Session("cabecera")

            If Session("EMPRESA") Is Nothing Then
                Session("EMPRESA") = New BCb2b.Cempresa(vEmpCod)
            End If
            Me.EMPRESA = Session("EMPRESA").PROP_COD

            'Dim vNOfe As String = vCabecera.prop_N_OFE

            Dim vGvagente As New BCb2b.gvagente()
            If Not Session("agente") Is Nothing Then
                vGvagente = Session("agente")
            Else
                Dim vGgclipr As New BCb2b.ggclipr(vGgcliprCod, vEmpgrupoCod, vTipVc, vConexion)
                vGvagente = New BCb2b.gvagente(vGgclipr.prop_GVAGENTE_COD, vEmpgrupoCod, 0)
            End If

            'FUNCIONES AJAX SOBRE CONTROLES
            tboxCodigoArt.Attributes.Add("onKeyPress", "javascript: return disableEnterKey(event);")
            tboxCodigoArt.Attributes.Add("onchange", "javascript:cambia_codigo_art('" & HFLINEA.ClientID & "','" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + vObstipArtIdiomas + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + tboxSuRef.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" & GetLocalResourceObject("ArticuloNoExiste") & "','" + lblprecio_teorico.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & imgEditTirasRollos.ClientID & "','" & imgEditTirasRollos.ClientID & "')")
            tboxSuRef.Attributes.Add("onblur", "javascript:lov_cambiar_su_ref('" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + vObstipArtIdiomas + "','" + Session("idioma") + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" & GetLocalResourceObject("ArticuloNoExiste") + "','" + lblprecio_teorico.ClientID + "','" + tboxSuRef.ClientID + "','" + GetLocalResourceObject("MsgModalModificarSuRef") + "','" + GetLocalResourceObject("MsgModaltextorepetidos") + "','" + GetLocalResourceObject("MsgModalmensajenoexiste") & "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & imgEditTirasRollos.ClientID & "')")
            tbox_cantidad.Attributes.Add("onKeyPress", "javascript: return disableEnterKey(event);")
            imgEditTirasRollos.Attributes.Add("onclick", "javascript:abrir_lov_tiras('" & tboxCodigoArt.ClientID & "', '" & tbox_cantidad.ClientID & "', '" & tboxDescripART.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "');")
            imgEditTirasRollos.Attributes.Add("style", "cursor:pointer;")
            tboxDescripART.Attributes.Add("onchange", "javascript:cambia_cantidad('" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + vCabecera.prop_N_OFE + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & vGvagente.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & vGaartESP & "','" & GetLocalResourceObject("MsgModalEsKit") & "')")
            tbox_cantidad.Attributes.Add("onchange", "javascript:cambia_cantidad('" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + vCabecera.prop_N_OFE + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & vGvagente.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & vGaartESP & "','" & GetLocalResourceObject("MsgModalEsKit") & "')")
            tboxPlazo.Attributes.Add("onchange", "javascript:cambia_cantidad('" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + vCabecera.prop_N_OFE + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & vGvagente.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & vGaartESP & "','" & GetLocalResourceObject("MsgModalEsKit") & "')")
            tbox_precio.Attributes.Add("onchange", "javascript:calcula_precio_final('" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + vCabecera.prop_N_OFE + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & vGvagente.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & vGaartESP & "','N')")
            tbox_dto.Attributes.Add("onchange", "javascript:calcula_precio_final('" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + vCabecera.prop_N_OFE + "','" + tboxPlazo.ClientID + "','" + tboxSuRef.ClientID + "','" + lblprecio_teorico.ClientID + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & ConfigurationManager.AppSettings("serieOferta") & "','" & GetLocalResourceObject("MsgArticuloCambiarPrecEsp") & "','" & vGvagente.prop_NOMBRE & " " & Date.Now & "','" & Unidad.ClientID & "','" & lblAncho.ClientID & "','" & lblLargo.ClientID & "','" & lblTiras.ClientID & "','" & lblRollos.ClientID & "','" & lblM2.ClientID & "','" & lblEquiUnPr.ClientID & "','" & lblDesperdicio.ClientID & "','" & Session("cultura") & "','" & vGaartESP & "','S')")
            imgBorrar.Attributes.Add("onclick", "javascript:borraLinea('" + vGgcliprCod + "','" + tboxCodigoArt.ClientID + "', '" + tboxDescripART.ClientID + "','" + tbox_cantidad.ClientID + "','" + lblPrecio.ClientID + "','" + tbox_precio.ClientID + "','" + lblDescuento.ClientID + "','" + tbox_dto.ClientID + "','" + lbltotal.ClientID + "','" + vTipoUsuario + "','" + lblModif.ClientID + "','" + HFLINEA.ClientID + "','" + vCabecera.prop_N_OFE + "','" + GetLocalResourceObject("lblResourceBorrarLineaConfirm.Text") + "','" & vEmpgrupoCod & "','" & vEmpCod & "','" & vTipVc & "','" & ConfigurationManager.AppSettings("serieOferta") & "')")
            'FIN FUNCIONES AJAX SOBRE CONTROLES

            ShowLupaArticulo(ibLupaArt, tboxCodigoArt, tboxDescripART, tbox_cantidad)
            ShowLupaSuRef(ibLupaSuRef, tboxCodigoArt, tboxDescripART, tboxSuRef, tbox_cantidad)

            'HACER QUE SI ES CLIENTE NO VEA LOS TEXTBOX DE PRECIOS Y SI ES OTRO PERFIL NO SE VEAN LOS LABEL.
            If (vTipoUsuario = "CL") Then
                lblPrecio.Attributes.Add("style", "display:inline")
                tbox_precio.Attributes.Add("style", "display:none")
                lblDescuento.Attributes.Add("style", "display:inline")
                tbox_dto.Attributes.Add("style", "display:none")
            Else
                lblPrecio.Attributes.Add("style", "display:none")
                tbox_precio.Attributes.Add("style", "display:inline")
                lblDescuento.Attributes.Add("style", "display:none")
                tbox_dto.Attributes.Add("style", "display:inline")
            End If

            If tboxGaartCod.Text <> "" And tbox_cantidad.Text <> "" Then
                Dim vParam As New BCb2b.CParametros()
                Dim vMargenCoste As Double = CDbl(vParam.dame_param("B2B_MARGEN_COSTE", vConexion))
                Dim vTarifaCoste As String = vParam.dame_param("B2B_TARIFA_COSTE", vConexion)

                Dim vGaartAux As New BCb2b.CArticulo(vEmpgrupoCod, tboxGaartCod.Text.ToUpper, vConexion)
                Dim vPrecioTarifa As Double = vGaartAux.calcula_precio_tarifa(vTarifaCoste, vTipVc, vConexion)
                Unidad.Text = vGaartAux.prop_gaunitip_uni1

                Dim vPrecioTarifaAux As Double = (vPrecioTarifa + (vPrecioTarifa * vMargenCoste) / 100) * CDbl(tbox_cantidad.Text)
                Dim vPrecioMinTeorico As Double = (vPrecioTarifa + (vPrecioTarifa * vMargenCoste) / 100)
                lblprecio_teorico.Text = FormatNumber(vPrecioMinTeorico, 2).ToString

                lblPrecio.Text = tbox_precio.Text 'almacenamos aqui el valor
                tbox_precio.Text = Obtener_precios(tboxGaartCod.Text.ToUpper, vGgcliprCod, tbox_cantidad.Text, Session("cultura"))
                If gaart_es_tira_o_rollo(vEmpgrupoCod, tboxGaartCod.Text.ToUpper) = "S" Then
                    tbox_cantidad.Enabled = False
                    tbox_precio.Enabled = False
                    If lblEquiUnPr.Text <> "" Then
                        tbox_cantidad.Text = lblM2.Text
                        tbox_precio.Text = Obtener_Precio_UnPr(vEmpgrupoCod, tboxGaartCod.Text.ToUpper(), tbox_precio.Text, tbox_cantidad.Text, lblEquiUnPr.Text, Session("cultura"))
                    End If
                    lblPrecio.Text = tbox_precio.Text
                End If
                If lblPrecio.Text = "" Then
                    lblPrecio.Text = tbox_precio.Text
                Else
                    tbox_precio.Text = lblPrecio.Text
                End If

                tbox_dto.Text = Obtener_descuento(tboxGaartCod.Text.ToUpper, vGgcliprCod, tbox_cantidad.Text, Session("cultura"))
                If lblDescuento.Text = "" Then
                    lblDescuento.Text = tbox_dto.Text
                Else
                    tbox_dto.Text = lblDescuento.Text
                End If

                Dim vCantidadAux As String = tbox_cantidad.Text
                If (lblTiras.Text <> "" Or lblRollos.Text <> "") And Unidad.Text <> "UN" Then
                    If lblTiras.Text <> "" Then
                        vCantidadAux = lblTiras.Text
                    End If
                    If lblRollos.Text <> "" Then
                        vCantidadAux = lblRollos.Text
                    End If
                End If

                lbltotal.Text = calcular_total_NP(vCantidadAux, tbox_precio.Text, tbox_dto.Text, Session("cultura"))

                Dim vEsTiraORollo As String = gaart_es_tira_o_rollo(vEmpgrupoCod, tboxGaartCod.Text.ToUpper)

                Dim vErrorCoste As Boolean = False
                Dim vAtencionCoste As Boolean = False
                Dim vObservacionCoste As String = ""

                Dim vGgclipr As New BCb2b.ggclipr()
                vGgclipr = Session("cliente")

                If (CDbl(lbltotal.Text) < CDbl(vPrecioTarifaAux)) And vEsTiraORollo = "N" And tboxGaartCod.Text.ToUpper <> vGaartESP.ToUpper Then
                    Dim vCodError As String = ValidarPrecioLinea(tboxGaartCod.Text, vGgclipr.prop_COD, tbox_precio.Text, tbox_cantidad.Text, tbox_dto.Text, Session("cultura"))
                    Dim vTipoError As String = Dame_TipoError_de_Error(vCodError)
                    vObservacionCoste = Obtener_Descrip_Error(vCodError, Session("cultura"))

                    'CAMBIAR COLOR DE FONDO DE FILA
                    Dim vClase As String = ""
                    Dim vClaseInf As String = ""
                    Select Case vTipoError
                        Case "#ERROR"
                            vErrorCoste = True 'Menor que CUC y que TARIF_ESTR
                            vClase = "error"
                            vClaseInf = "error_suave"
                        Case "#WARNING"
                            vAtencionCoste = True 'Menor que CUC pero no menor que TARIF_ESTR
                            vClase = "atencion"
                            vClaseInf = "atencion_suave"
                        Case "#OK"
                    End Select
                    e.Row.CssClass = vClase
                    Dim i As Integer = 0
                    For i = 0 To e.Row.Cells.Count - 1
                        e.Row.Cells(i).CssClass = vClase
                    Next
                    'FIN CAMBIAR COLOR DE FONDO DE FILA

                    If vTipoError <> "#OK" Then 'Añadimos la línea nueva para mostrar el error.
                        Me.num_lineas_error_costo = Me.num_lineas_error_costo + 1
                        AddNewRow(BulkEditGridView1, e, Me.num_lineas_error_costo, vObservacionCoste, vClaseInf)
                    End If
                End If

                Dim vLineaOfe As New BCb2b.COferta_linOff(vEmpgrupoCod, vEmpCod, vTipVc, vCabecera.prop_ggofetip_cod, vCabecera.prop_N_OFE, HFLINEA.Value, tboxGaartCod.Text.ToUpper, tboxDescripART.Text, tbox_cantidad.Text, tbox_precio.Text, "", Unidad.Text, vCabecera.prop_ggclipr_cod, tbox_dto.Text, tboxPlazo.Text, True, vErrorCoste, vAtencionCoste, lblAncho.Text, lblLargo.Text, lblTiras.Text, lblRollos.Text, lblM2.Text, lblEquiUnPr.Text, lblDesperdicio.Text, vObservacionCoste)
                Dim vListaLineas As New List(Of BCb2b.COferta_linOff)
                Try
                    'OBTENEMOS LINEAS Y ASIGNAMOS LA LINEA ACTUAL CON EL ERROR
                    vListaLineas = Session("lineasOferta")
                    vListaLineas(HFLINEA.Value - 1) = vLineaOfe
                    Session("lineasOferta") = vListaLineas
                Catch ex As Exception
                    Log.Error(ex, "[CrearOferta.AsignandoLin]")
                End Try

            End If
        End If
    End Sub
    Protected Sub BulkEditGridView1_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles BulkEditGridView1.RowCommand
        BulkEditGridView1.Save()
    End Sub
    Protected Sub TimerSesion_Tick(sender As Object, e As EventArgs) Handles TimerSesion.Tick
        BulkEditGridView1.DataBind()
    End Sub
    'FIN GESTION DE LINEAS DEL BULKEDITOR

    'CLICK DE BOTONES
    Protected Sub btnContinuar_Click(sender As Object, e As EventArgs) Handles btnContinuar.Click
        BulkEditGridView1.DataBind()
    End Sub
    Protected Sub btnRealizar_Click(sender As Object, e As EventArgs) Handles btnRealizar.Click
        guardar_info_cabecera()
        Dim vLineasOferta As New List(Of BCb2b.COferta_linOff)
        If Not Session("lineasOferta") Is Nothing Then
            vLineasOferta = Session("lineasOferta")
        End If
        If vLineasOferta.Count > 0 Then
            Server.Transfer("OfertaValidar.aspx")
        Else
            'MOSTRAR ERROR SIN LINEAS.
            Modal.Show(Me, GetGlobalResourceObject("general", "MsgModalbtnAtencion"), GetGlobalResourceObject("general", "NoLineasIntroduc"), "ALERT")
        End If
    End Sub
    'FIN CLICK DE BOTONES

    'EVENTOS CAJAS DE TEXTO
    Protected Sub tboxAtte_TextChanged(sender As Object, e As EventArgs) Handles tboxAtte.TextChanged
        guardar_info_cabecera()
    End Sub
    Protected Sub tboxRefCli_TextChanged(sender As Object, e As EventArgs) Handles tboxRefCli.TextChanged
        guardar_info_cabecera()
    End Sub
    Protected Sub txtarea_observacion_TextChanged(sender As Object, e As EventArgs) Handles txtarea_observacion.TextChanged
        guardar_info_cabecera()
    End Sub
    Protected Sub txtarea_observacion_pie_TextChanged(sender As Object, e As EventArgs) Handles txtarea_observacion_pie.TextChanged
        guardar_info_cabecera()
    End Sub
    'FIN EVENTOS CAJAS DE TEXTO

    'EVENTOS COMBOS
    Protected Sub comboModosEnvio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles comboModosEnvio.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
    Protected Sub DDLDir_Envio_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLDir_Envio.SelectedIndexChanged
        Dim vConexion As String = Conexion.GenerarStringConexion(Me)
        Dim dir_sel As New BCb2b.CDirecciones(lblRSocial.Text, DDLDir_Envio.SelectedValue, vConexion)
        Try
            lbldir.Text = dir_sel.PROP_DIR
            lblCP.Text = dir_sel.PROP_COD_POSTAL
            lblProvi.Text = dir_sel.PROP_PROVI_NOM
            lblTfono.Text = dir_sel.PROP_TELEFONOS
            lblPoblacion.Text = dir_sel.PROP_POBLAC_NOM
            lblpais.Text = dir_sel.PROP_PAISES_nom
            lblFax.Text = dir_sel.PROP_TELEFAX

            guardar_info_cabecera()
        Catch ex As Exception
            Log.Error(ex, "[CrearOferta.DDLDir_Envio_SelectedIndexChanged] dir = {@dir} ", dir_sel)
        End Try
    End Sub
    Protected Sub ddlFPago_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ddlFPago.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
    Protected Sub DDLSeries_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DDLSeries.SelectedIndexChanged
        guardar_info_cabecera()
    End Sub
    'FIN EVENTOS COMBOS
End Class
